freeslot("MT_MIC", "S_MIC", "S_MICD", "SPR_MIC_", "MT_BFARROW", "SPR_BFAR", "S_BFARROW", "S_BFARROWUSE", "S_DOWNBFARROW", "S_DOWNBFARROWUSE")

freeslot("sfx_bee", "sfx_bep", "sfx_boa", "sfx_dah", "sfx_gas")

local randombeep = {
sfx_bee, sfx_bep,
sfx_boa, sfx_dah}

//Old Arrow Splashes Start
for i = 1, 8
freeslot("SPR_ASPL", "S_BFARROWSPLASH"..i)
end

/*states[S_BFARROWSPLASH1] = {SPR_ASPL, A, 2,nil, 0, 0,S_BFARROWSPLASH2}
states[S_BFARROWSPLASH2] = {SPR_ASPL, B, 2,nil, 0, 0,S_BFARROWSPLASH3}
states[S_BFARROWSPLASH3] = {SPR_ASPL, C, 2,nil, 0, 0,S_BFARROWSPLASH4}
states[S_BFARROWSPLASH4] = {SPR_ASPL, D, 2,nil, 0, 0,S_BFARROWSPLASH5}
states[S_BFARROWSPLASH5] = {SPR_ASPL, E, 2,nil, 0, 0,S_BFARROWSPLASH6}
states[S_BFARROWSPLASH6] = {SPR_ASPL, F, 2,nil, 0, 0,S_BFARROWSPLASH7}
states[S_BFARROWSPLASH7] = {SPR_ASPL, G, 2,nil, 0, 0,S_BFARROWSPLASH8}
states[S_BFARROWSPLASH8] = {SPR_ASPL, H, 2,nil, 0, 0,S_NULL}

local function ArrowSplash(mo, skincolor)
	local bomb = P_SpawnMobj(mo.x, mo.y, mo.z+50*FRACUNIT, [MT_THOK)
	bomb.color = skincolor
	bomb.state = S_BFARROWSPLASH1
	bomb.scale = FRACUNIT/2
end*/
//Old Arrow Splashes End

//New Arrow Splashes Start
freeslot("S_BFARROWSPLASH")

states[S_BFARROWSPLASH] = {SPR_ASPL, A, 16, nil, 0, 0, S_NULL}

local function ArrowSplash(mo, arrowcolor)
	for i = 1, 10
		local bomb = P_SpawnMobj(mo.x, mo.y, mo.z+50*FRACUNIT, MT_THOK)
		bomb.color = arrowcolor
		bomb.state = S_BFARROWSPLASH
		bomb.scale = FRACUNIT*2
		bomb.renderflags = RF_FULLBRIGHT
		bomb.flags2 = 0
		P_InstaThrust(bomb, P_RandomRange(0, 360)*ANG1, P_RandomRange(0, 10)*FRACUNIT)
		P_SetObjectMomZ(bomb, P_RandomRange(-5, 5)*FRACUNIT)
		if mo.eflags & MFE_VERTICALFLIP
			bomb.eflags = $|MFE_VERTICALFLIP
			bomb.flags2 = $|MF2_OBJECTFLIP
		else
			bomb.eflags = $ & ~MFE_VERTICALFLIP
			bomb.flags2 = $ & ~MF2_OBJECTFLIP
		end
	end	
end

addHook("MobjThinker", function(mo)
	if mo.scale == FRACUNIT*2 and mo.state == S_BFARROWSPLASH
		local smol = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		smol.scale = (FRACUNIT*2)-1
		smol.state = S_BFARROWSPLASH
		smol.color = mo.color
		smol.renderflags = RF_FULLBRIGHT
		smol.flags2 = 0
		if mo.eflags & MFE_VERTICALFLIP
			smol.eflags = $|MFE_VERTICALFLIP
			smol.flags2 = $|MF2_OBJECTFLIP
		else
			smol.eflags = $ & ~MFE_VERTICALFLIP
			smol.flags2 = $ & ~MF2_OBJECTFLIP
		end
		
		mo.momx = FixedMul($, 9*FRACUNIT/10)
		mo.momy = FixedMul($, 9*FRACUNIT/10)
		mo.momz = FixedMul($, 9*FRACUNIT/10)
	end
end, MT_THOK)

addHook("MobjThinker", function(mo)
	if mo.scale < FRACUNIT*2 and mo.state == S_BFARROWSPLASH
		mo.scale = $ - FRACUNIT/5
	end
end, MT_THOK)

local function GhostAbsorb(mo, skincolor)
	local ghost = P_SpawnGhostMobj(mo)
	ghost.color = skincolor
	ghost.colorized = true
	ghost.scale = FRACUNIT*2
	ghost.fuse = 15
	ghost.blendmode = AST_ADD
	ghost.wherescale = FRACUNIT
	ghost.tpto = mo
	if mo.eflags & MFE_VERTICALFLIP
		ghost.eflags = $|MFE_VERTICALFLIP
		ghost.flags2 = $|MF2_OBJECTFLIP
	else
		ghost.eflags = $ & ~MFE_VERTICALFLIP
		ghost.flags2 = $ & ~MF2_OBJECTFLIP
	end
end
//New Arrow Splashes End


local function BuggieHoming(mo, speed, target2)
	local targetang
	if target2
		targetang = R_PointToAngle2(mo.x, mo.y, target2.x, target2.y)
	end	
	mo.player.drawangle = targetang
	if ((mo.z > target2.z+target2.height) and P_MobjFlip(mo) == 1)
	or ((mo.z < target2.z) and P_MobjFlip(mo) == -1)
		if not mo.momz == 0
			P_SetObjectMomZ(mo, -1*FRACUNIT, true)
		else
			P_SetObjectMomZ(mo, -5*FRACUNIT, false)
		end	
	end						
	if ((mo.z > target2.z+target2.height) and P_MobjFlip(mo) == -1)
	or ((mo.z < target2.z) and P_MobjFlip(mo) == 1)
		if not mo.momz == 0
			P_SetObjectMomZ(mo, 1*FRACUNIT, true)
		else
			P_SetObjectMomZ(mo, 5*FRACUNIT, false)
		end	
	end			
	P_Thrust(mo, targetang, speed)
	mo.player.pflags = $|PF_JUMPED
end	

local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("MobjLineCollide", function(mo, line)
  if not mo return end
  if not (mo.type == MT_MIC or (mo.type == MT_PLAYER and mo.player.heavy > 0)) return end

  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndCrumble(mo, sec)
  end
end)

local function MicThink(mo)
	if mo.thrower and mo.thrower.valid
	and mo.valid
		mo.thrower.player.micd = mo
		if mo.attract == nil
			mo.attract = false
		end
		if mo.timer == nil
			mo.timer = 100
		end
		if mo.timer <= 0
			mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			if mo.timer <= -100
				P_TeleportMove(mo, mo.thrower.x, mo.thrower.y, mo.thrower.z)
			end
			if mo.timer <= -200
				mo.thrower.player.micthrow = false
				mo.thrower.player.grapple = false
				mo.thrower.player.stopgrapple = false
				P_KillMobj(mo)
			end
		end
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.thrower.x, mo.thrower.y)+ANGLE_180
		if mo.flags2 & MF2_EXPLOSION or mo.state != S_MIC
			mo.thrower.player.micthrow = false
		end
		if not (mo.thrower.player.cmd.buttons & BT_SPIN)
		and mo.thrower.player.grapple == false
			mo.attract = true
			if mo.timer <= 0
				mo.timer = 50
			end	
		end
		if mo.attract == true
			P_HomingAttack(mo, mo.thrower)
			mo.timer = $ - 1
			if mo.x <= mo.thrower.x + mo.thrower.radius and mo.x >= mo.thrower.x - mo.thrower.radius
			and mo.y <= mo.thrower.y + mo.thrower.radius and mo.y >= mo.thrower.y - mo.thrower.radius
			and mo.z <= mo.thrower.z + mo.thrower.height and mo.z >= mo.thrower.z
				mo.thrower.player.micthrow = false
				mo.attract = false
				P_KillMobj(mo)
				if not P_IsObjectOnGround(mo.thrower)
					mo.thrower.player.pflags = $|PF_THOKKED
				end
			end
		end
		if mo.thrower.player.grapple == true
			if mo.x <= mo.thrower.x + mo.thrower.radius and mo.x >= mo.thrower.x - mo.thrower.radius
			and mo.y <= mo.thrower.y + mo.thrower.radius and mo.y >= mo.thrower.y - mo.thrower.radius
			and mo.z <= mo.thrower.z + mo.thrower.height and mo.z >= mo.thrower.z
				mo.thrower.player.micthrow = false
				mo.attract = false
				mo.thrower.player.grapple = false
				if not P_IsObjectOnGround(mo.thrower)
					mo.thrower.player.pflags = $|PF_THOKKED
				end
				P_KillMobj(mo)
				if mo.thrower.player.stopgrapple == false
					mo.thrower.momx = 0
					mo.thrower.momy = 0
					P_SetObjectMomZ(mo.thrower, 8*FRACUNIT)
					mo.thrower.player.pflags = $|PF_JUMPED|PF_THOKKED
				end	
			end
		end	
		CheckAndCrumble(mo, mo.subsector.sector)
	end
end

addHook("MobjThinker", MicThink, MT_MIC)

local function Rundust(mo)
	local momangle2 = R_PointToAngle2(0,0, mo.momx, mo.momy)
	local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
	P_InstaThrust(dust, momangle2 + P_RandomRange(-15, 15)*ANG1, P_RandomRange(5, 30)*FRACUNIT)
	dust.momz = P_RandomRange(0, 5)*FRACUNIT
	dust.eflags = $1 | (mo.eflags & MFE_VERTICALFLIP)
	if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
		dust.state = S_SPINDUST_BUBBLE1
	end
end	

freeslot("SKINCOLOR_BOOSTMODEP", "SKINCOLOR_BOOSTMODER", "SKINCOLOR_JUMPBOOSTG", "SKINCOLOR_HEAVYB", "SKINCOLOR_COMBINEY")

skincolors[SKINCOLOR_BOOSTMODEP] = {
    name = "BoostmodeP",
    ramp = {164,164,164,164,164,164,164,164,164,164,164,164,164,164,164,164},
    invcolor = SKINCOLOR_PURPLE,
    invshade = 0,
    chatcolor = V_PURPLEMAP,
    accessible = false
}

skincolors[SKINCOLOR_BOOSTMODER] = {
    name = "BoostmodeR",
    ramp = {35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35},
    invcolor = SKINCOLOR_RED,
    invshade = 0,
    chatcolor = V_REDMAP,
    accessible = false
}

skincolors[SKINCOLOR_JUMPBOOSTG] = {
    name = "JumpboostG",
    ramp = {114,114,114,114,114,114,114,114,114,114,114,114,114,114,114,114},
    invcolor = SKINCOLOR_GREEN,
    invshade = 0,
    chatcolor = V_GREENMAP,
    accessible = false
}

skincolors[SKINCOLOR_HEAVYB] = {
    name = "HeavyB",
    ramp = {152,152,152,152,152,152,152,152,152,152,152,152,152,152,152,152},
    invcolor = SKINCOLOR_BLUE,
    invshade = 0,
    chatcolor = V_BLUEMAP,
    accessible = false
}

skincolors[SKINCOLOR_COMBINEY] = {
    name = "CombineY",
    ramp = {74,74,74,74,74,74,74,74,74,74,74,74,74,74,74,74},
    invcolor = SKINCOLOR_YELLOW,
    invshade = 0,
    chatcolor = V_YELLOWMAP,
    accessible = false
}

local boostcolor = {
	[SKINCOLOR_RED] = SKINCOLOR_BOOSTMODER,
	[SKINCOLOR_PURPLE] = SKINCOLOR_BOOSTMODEP
}

freeslot("S_PLAY_BOOSTARROW", "S_PLAY_SPRINGARROW", "S_PLAY_TIMEARROW", "SPR2_REDP", "SPR2_GREU", "SPR2_TARW", "S_PLAY_DODGE", "SPR2_DOGE")

states[S_PLAY_SPRINGARROW] = {
	sprite = SPR_PLAY,
	frame = SPR2_GREU,
	tics = 20,
	nextstate = S_PLAY_STND
}

states[S_PLAY_BOOSTARROW] = {
	sprite = SPR_PLAY,
	frame = SPR2_REDP,
	tics = 20,
	nextstate = S_PLAY_STND
}

states[S_PLAY_TIMEARROW] = {
	sprite = SPR_PLAY,
	frame = SPR2_TARW,
	tics = 20,
	nextstate = S_PLAY_STND
}

states[S_PLAY_DODGE] = {
	sprite = SPR_PLAY,
	frame = SPR2_DOGE,
	tics = 25,
	nextstate = S_PLAY_STND
}

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	//and not player.rapbattle
		if player.boostmode == nil
			player.boostmode = 0
		end	
		
		if player.heavy == nil
			player.heavy = 0
		end	
		if player.strengh == nil
			player.strengh = 0
		end	
		if player.boostcombo == nil
			player.boostcombo = 0
		end	
		
		if not player.mo.updash
			player.mo.updash = -1
		end
		if S_SoundPlaying(player.mo, sfx_gas)
			player.boostmode = 2
		end
		if player.mo.updash > -1
			player.mo.updash = $ - 1
			S_StartSound(player.mo, sfx_spndsh)
			if (leveltime%2) == 1
				for i = 1, player.mo.updash
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.colorized = true
					ghost.color = SKINCOLOR_JUMPBOOSTG
					ghost.fuse = 3
					P_InstaThrust(ghost, P_RandomRange(0, 360)*ANG1, player.mo.updash*FRACUNIT)
				end	
			end	
			if player.mo.updash == 0
				player.mo.updash = -1
				P_SetObjectMomZ(player.mo, 15*FRACUNIT)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $|PF_JUMPED
				S_StartSound(player.mo, sfx_spdpad)
				ArrowSplash(player.mo, SKINCOLOR_GREEN)
			end
		end
		
		if player.boostmode == 1
			S_StartSound(player.mo, sfx_kc65)
			player.normalspeed = skins[player.mo.skin].normalspeed
			player.charflags = skins[player.mo.skin].flags
			player.jumpfactor = skins[player.mo.skin].jumpfactor
			player.boostmode = $ - 1
			ArrowSplash(player.mo, boostcolor[player.boostcolor])
			if S_SoundPlaying(player.mo, sfx_gas)
				S_StopSoundByID(player.mo, sfx_gas)
			end	
			S_FadeMusic(100, 5, player)
			player.boostcombo = 0
		end
		
		if player.heavy == 1
			S_StartSound(player.mo, sfx_kc65)
			player.normalspeed = skins[player.mo.skin].normalspeed
			player.charflags = skins[player.mo.skin].flags
			player.jumpfactor = skins[player.mo.skin].jumpfactor
			player.heavy = $ - 1
			ArrowSplash(player.mo, SKINCOLOR_BLUE)
		end
		if player.heavy > 0
			if (leveltime % 10) == 1
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.colorized = true
				ghost.color = SKINCOLOR_HEAVYB
				ghost.blendmode = AST_ADD
			end
			if not P_IsObjectOnGround(player.mo)
			and ((player.mo.momz > 0 and P_MobjFlip(player.mo) == -1)
			or (player.mo.momz < 0 and P_MobjFlip(player.mo) == 1))
				player.strengh = abs(player.mo.momz)*20
			end
			player.heavy = $ - 1
			player.charflags = $|SF_CANBUSTWALLS
			player.jumpfactor = skins[player.mo.skin].jumpfactor/2
			player.normalspeed = skins[player.mo.skin].normalspeed/2
			player.powers[pw_invulnerability] = 2
			CheckAndCrumble(player.mo, player.mo.subsector.sector)
			if player.mo.eflags & MFE_JUSTHITFLOOR
				P_Earthquake(player.mo, player.mo, player.strengh)
			end
		end	
		
		if P_IsObjectOnGround(player.mo)
			if player.boostmode > 0
				if not (player.pflags & PF_SPINNING)
					Rundust(player.mo)
				end
				if player.speed < (skins[player.mo.skin].normalspeed - 10*FRACUNIT)
					player.boostmode = 2
				end
			end	
		end
		if player.boostmode > 0
			if (leveltime % 3) == 1
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.colorized = true
				if player.boostcolor
					ghost.color = boostcolor[player.boostcolor]
				end	
				ghost.blendmode = AST_ADD
			end
			player.boostmode = $ - 1
			player.charflags = $|SF_RUNONWATER|SF_CANBUSTWALLS
			player.jumpfactor = skins[player.mo.skin].jumpfactor + (FRACUNIT/5)
			player.normalspeed = skins[player.mo.skin].normalspeed + 10*FRACUNIT
		end	
	end
end)	

local function SphereToCartesian(alpha, beta)
    local t = {}

    t.x = FixedMul(cos(alpha), cos(beta))
    t.y = FixedMul(sin(alpha), cos(beta))
    //t.z = sin(beta)
    t.z = FixedMul(sin(alpha), sin(beta)) -- for elliptical orbit

    return t
end	

freeslot("S_UPAIM")

local dodgetypes = {
	[MT_POINTYBALL] = true,
	[MT_FACESTABBERSPEAR] = true,
	[MT_PYREFLY_FIRE] = true,
	[MT_DRAGONMINE] = true,
	[MT_GOOP] = true,
	[MT_GOOPTRAIL] = true,
	[MT_SHOCKWAVE] = true,
	[MT_EGGMOBILE4_MACE] = true,
	[MT_FBOMB] = true,
	[MT_CYBRAKDEMON_MISSILE] = true,
	[MT_CYBRAKDEMON_FLAMESHOT] = true,
	[MT_CYBRAKDEMON_FLAMEREST] = true,
	[MT_CYBRAKDEMON_NAPALM_BOMB_SMALL] = true,
	[MT_CYBRAKDEMON_NAPALM_BOMB_LARGE] = true,
	[MT_CYBRAKDEMON_NAPALM_FLAMES] = true,
	[MT_CYBRAKDEMON_VILE_EXPLOSION] = true,
	[MT_SPIKEBALL] = true,
	[MT_DEMONFIRE] = true,
	[MT_ROCKET] = true,
	[MT_TORPEDO] = true,
	[MT_TORPEDO2] = true,
	[MT_ENERGYBALL] = true,
	[MT_MINE] = true,
	[MT_JETTBULLET] = true,
	[MT_TURRETLASER] = true,
	[MT_CANNONBALL] = true,
	[MT_ARROW] = true,
	[MT_SMALLMACE] = true,
	[MT_BIGMACE] = true,
	[MT_CORK] = true,
	[MT_LHRT] = true,
	[MT_REDRING] = true,
	[MT_THROWNBOUNCE] = true,
	[MT_THROWNINFINITY] = true,
	[MT_THROWNAUTOMATIC] = true,
	[MT_THROWNSCATTER] = true,
	[MT_THROWNEXPLOSION] = true,
	[MT_THROWNGRENADE] = true,
	[MT_FIREBALL] = true,
	[MT_FIREBALLTRAIL] = true,
	[MT_LASER] = true
}

local function WhereMissile(p)
	local lastmo
	local dist
	local lastdist = 0
	for mo in mobjs.iterate()		
			if (dodgetypes[mo.type] != true)
				continue
			end
			dist = P_AproxDistance(P_AproxDistance(p.mo.x - mo.x, p.mo.y - mo.y), p.mo.z - mo.z)
				if (mo == p.mo) and (mo.health <= 0) and ((lastmo and (dist > lastdist)))		
					continue
				end
		lastmo = mo
		lastdist = dist		
	end
	return lastmo
end
rawset(_G, "P_FlyTo", function(mo, fx, fy, fz, sped, addques)
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = $ + FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = $ + FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		else
			mo.momx = FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		end	
	end	
end) 
local function TouchSpecialZCheck(mo, mobj)
	if ((mobj.z < mo.z + mo.height)
	and (mo.z < mobj.z + mobj.height)
	and (mobj.z + mobj.height > mo.z)
	and (mo.z + mo.height > mobj.z))
		return true
	end
end		
addHook("PlayerThink", function(player)
	if player.valid and player.mo.skin == "boyfriend" and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and player.rapbattle == false
		local wheremissile = WhereMissile(player)
		if wheremissile
			player.themissile = wheremissile
		else
			player.themissile = nil
		end	
		if player.dodge == nil
			player.dodge = 0
		end
		if player.dodge
			player.dodge = $ - 1
		end
		if player.wheremissile == nil
			player.wheremissile = 0
		end
		if player.themissile
			player.wheremissile = R_PointToDist2(player.mo.x, player.mo.y, player.themissile.x, player.themissile.y)
			if (leveltime%5) == 1
				player.prewheremissile = R_PointToDist2(player.mo.x, player.mo.y, player.themissile.x, player.themissile.y)
			end
		end	
		if player.micthrow == nil
			player.micthrow = false
		end
		if player.mo.updash == nil
			player.mo.updash = -1
		end	
		if player.slide == nil
			player.slide = false
		end
		if player.arrowcount == nil
			player.arrowcount = 0
		end
		if player.grapple == nil
			player.grapple = false
		end
		if player.stopgrapple == nil
			player.stopgrapple = false
		end
		if not player.arrows or player.arrows[1] == nil
			player.arrows = {}
			player.arrowcount = 0
		end	
		if player.mo.state == S_PLAY_SPRINGARROW
			player.pflags = $|PF_FULLSTASIS
		end
		if player.mo.state == S_PLAY_DODGE
			player.pflags = $|PF_FULLSTASIS
		end
		if player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH
			player.pflags = $|PF_STASIS
		end
		if not player.micd
			player.micthrow = false
			if P_IsObjectOnGround(player.mo)
				player.grapple = false
				player.stopgrapple = false
			end
		end
		if P_IsObjectOnGround(player.mo) 
		and player.grapple == false
			player.stopgrapple = false
		end
		if player.grapple == true
		and not (player.pflags & PF_THOKKED)
			if player.micd and player.micd.valid
				if player.stopgrapple == false
					P_FlyTo(player.micd, player.mo.x, player.mo.y, player.mo.z, 40*FRACUNIT)
				end	
				if player.cmd.buttons & BT_JUMP
				and player.jump == false
					player.micd.attract = true
					player.stopgrapple = true
				end
			else
				if P_IsObjectOnGround(player.mo)
					player.grapple = false
					player.stopgrapple = false
				end
			end	
		end
		if player.cmd.buttons & BT_CUSTOM1
			if player.custom1 == false
			and player.arrowcount < 2
			and (not player.themissile or player.themissile and player.wheremissile and player.wheremissile > 500*FRACUNIT)
			//and not (player.wheremissile <= player.prewheremissile)
				local gotox = player.mo.x + FixedMul(150*FRACUNIT, cos(player.mo.angle))
				local gotoy = player.mo.y + FixedMul(150*FRACUNIT, sin(player.mo.angle))
			
				local arrow = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BFARROW)
				P_InstaThrust(arrow, player.mo.angle, 15*FRACUNIT)
				P_SetObjectMomZ(arrow, 5*FRACUNIT)
				arrow.whocreator = player.mo
				arrow.scale = 0
				arrow.nope = 15
				arrow.fuse = 1000
				player.sing = 15
				if player.mo.eflags & MFE_VERTICALFLIP
					arrow.eflags = $|MFE_VERTICALFLIP
					arrow.flags2 = $|MF2_OBJECTFLIP
				else
					arrow.eflags = $ & ~MFE_VERTICALFLIP
					arrow.flags2 = $ & ~MF2_OBJECTFLIP
				end
				player.arrowcount = $ + 1
				player.arrows[player.arrowcount] = arrow
				S_StartSound(player.mo, randombeep[P_RandomRange(1, 4)])
				if not (player.cmd.forwardmove or player.cmd.sidemove)
				and not (player.cmd.forwardmove < -35)
					arrow.color = SKINCOLOR_GREEN
					player.mo.state = S_PLAY_SPRINGARROW
				elseif not (player.cmd.forwardmove < -35)
					local randomcolor = P_RandomRange(1, 2)
					if randomcolor == 1
						arrow.color = SKINCOLOR_PURPLE
					else
						arrow.color = SKINCOLOR_RED
					end	
					player.mo.state = S_PLAY_BOOSTARROW
				else
					arrow.color = SKINCOLOR_BLUE
					arrow.state = S_DOWNBFARROW
					player.mo.state = S_PLAY_TIMEARROW
				end	
			end
			if player.custom1 == false
			and player.wheremissile <= 100*FRACUNIT
			and player.wheremissile > 0
			and player.wheremissile <= player.prewheremissile
				player.dodge = 15
				player.mo.state = S_PLAY_DODGE
			end
			player.custom1 = true
		else
			player.custom1 = false
		end
		if player.aimup == true
			P_SpawnLockOn(player, player.mo, S_UPAIM)
		end
		if player.cmd.buttons & BT_SPIN
			if player.cmd.buttons & BT_JUMP
			and player.micd
			and player.grapple == false
			and player.jump == false
			and not (player.pflags & PF_THOKKED)
				if player.micd.valid
					player.pflags = $|PF_THOKKED	
					P_FlyTo(player.mo, player.micd.x, player.micd.y, player.micd.z, 36*FRACUNIT)
					/*local wheremic = R_PointToAngle2(player.mo.x, player.mo.y, player.micd.x, player.micd.y)
					local wheremicz
					local thrustforce = R_PointToDist2(player.mo.x, player.mo.y, player.micd.x, player.micd.y)
					P_InstaThrust(player.mo, wheremic, (thrustforce/10)+10*FRACUNIT)
					if player.micd.z >= player.mo.z
						wheremicz = FixedSqrt(player.mo.z)-FixedSqrt(player.micd.z)
						P_SetObjectMomZ(player.mo, -wheremicz)
					else
						player.mo.momz = 0
					end*/
					player.grapple = true
				end	
			end
			if player.micthrow == false
			and player.spin == false
			and player.grapple == false
				if not (player.cmd.sidemove or player.cmd.forwardmove) or not P_IsObjectOnGround(player.mo)
					local mic = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_MIC)
					if mic
						mic.tracer = player.mo
						mic.target = player.mo
						mic.thrower = player.mo
						mic.scale = FRACUNIT*2
						if player.mo.eflags & MFE_VERTICALFLIP
							mic.eflags = $|MFE_VERTICALFLIP
							mic.flags2 = $|MF2_OBJECTFLIP
						else
							mic.eflags = $ & ~MFE_VERTICALFLIP
							mic.flags2 = $ & ~MF2_OBJECTFLIP
						end
						if player.aimup != true
							P_Thrust(mic, player.mo.angle, cos(player.aiming)*30)
							P_SetObjectMomZ(mic, player.mo.momz + sin(player.aiming)*20)
						else
							P_Thrust(mic, player.mo.angle, 5*FRACUNIT)
							P_SetObjectMomZ(mic, 10*FRACUNIT, true)
						end	
					end	
					player.micthrow = true
					player.mo.state = S_PLAY_FIRE
					player.aimup = false
				else
					player.pflags = $|PF_SPINNING
					player.slide = true
				end
			end
			player.spin = true
		else
			player.spin = false
		end
		if player.slide == true
			if not (player.pflags & PF_SPINNING)
				player.slide = false
			else
				player.mo.state = S_PLAY_GLIDE_LANDING
			end	
		end
		if player.cmd.buttons & BT_JUMP
			player.jump = true
		else
			player.jump = false
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.valid and player.mo.skin == "boyfriend" and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and not player.rapbattle
		if player.micthrow == false
		and player.grapple == false
			if player.aimup != true
				player.aimup = true
			else
				player.aimup = false
			end
		end
	end
end)

local function MicKill(mo, enemy)
	if mo.valid and mo.thrower and mo.thrower.valid and mo.thrower.skin == "boyfriend"
    and (enemy.flags & MF_ENEMY or enemy.flags & MF_BOSS or enemy.flags & MF_MONITOR or enemy.type == MT_SPIKE)
		if (mo.x <= enemy.x + enemy.radius and mo.x >= enemy.x - enemy.radius
		and mo.y <= enemy.y + enemy.radius and mo.y >= enemy.y - enemy.radius
		and mo.z <= enemy.z + enemy.height and mo.z >= enemy.z) or 
			(enemy.x <= mo.x + mo.radius and enemy.x >= mo.x - mo.radius
		and enemy.y <= mo.y + mo.radius and enemy.y >= mo.y - mo.radius
		and enemy.z <= mo.z + mo.height and enemy.z >= mo.z)
			if enemy.type == MT_SPIKE
				P_KillMobj(enemy, mo.thrower, mo.thrower)
			else
				P_DamageMobj(enemy, mo.thrower, mo.thrower)
			end
		end
    end
end

addHook("MobjCollide", MicKill, MT_MIC)
addHook("MobjMoveCollide", MicKill, MT_MIC)

freeslot("S_GLOW")

local function ArrowThink(mo)
	if mo.valid and mo.type == MT_BFARROW
		/*if mo.followmic and mo.followmic.valid
			local aprx = P_AproxDistance(P_AproxDistance(mo.followmic.x - mo.x, mo.followmic.y - mo.y), mo.followmic.z - mo.z)
			P_FlyTo(mo, mo.followmic.x, mo.followmic.y, mo.followmic.z, aprx/8)
		end*/
		if mo.floatz == nil
			mo.floatz = 0
		end
		if mo.glow == nil
			mo.glow = 0
		end
		if mo.floatmath == nil
			mo.floatmath = 0
		end
		if mo.color == SKINCOLOR_BLUE
			if mo.state == S_BFARROWUSE
				mo.state = S_DOWNBFARROWUSE
			end
		end	
		mo.floatz = $ + 5
		mo.floatmath = FRACUNIT+FixedMul(sin(mo.floatz*ANG1), FRACUNIT*5)
		//P_TeleportMove(mo, mo.x, mo.y, (mo.floorz + 50*FRACUNIT) + mo.floatmath)
		if (mo.state == S_BFARROW or mo.state == S_DOWNBFARROW)
			mo.angle = $+5*ANG1
			mo.spriteyoffset = 12*FRACUNIT + mo.floatmath
			mo.glow = 0
		else
			mo.angle = $+25*ANG1
			mo.scale = $ + FRACUNIT/15
			mo.spriteyoffset = 15*FRACUNIT + mo.floatmath
			mo.glow = $+1
			for i = 1, mo.glow
				local glow = P_SpawnMobj(mo.x, mo.y, mo.z+(50-15)*FRACUNIT, MT_THOK)
				glow.color = mo.color
				glow.fuse = i
				glow.spriteyoffset = -(43*FRACUNIT)/2
				glow.blendmode = AST_ADD
				glow.scale = FRACUNIT/100 + ((FRACUNIT/5)*i)
				if mo.whocreator.eflags & MFE_VERTICALFLIP
					glow.eflags = $|MFE_VERTICALFLIP
					glow.flags2 = $|MF2_OBJECTFLIP
				else
					glow.eflags = $ & ~MFE_VERTICALFLIP
					glow.flags2 = $ & ~MF2_OBJECTFLIP
				end
			end
		end	
		if mo.scale < FRACUNIT
			mo.scale = $ + FRACUNIT/5
		end
		if mo.scale > FRACUNIT
		and (mo.state != S_BFARROW or mo.state != S_DOWNBFARROW)
			mo.scale = FRACUNIT
		end
		if mo.nope
			mo.nope = $ - 1
		end
	end
end

addHook("MobjThinker", ArrowThink, MT_BFARROW)

local function MicThink(mo)
	if mo.valid
		for mobj in mobjs.iterate()
			if mobj and mobj.valid
			and mobj.type == MT_BFARROW
			and R_PointToDist2(mobj.x, mobj.y, mo.x, mo.y) <= 50*FRACUNIT
			and TouchSpecialZCheck(mobj, mo)
			and not mobj.followmic
				//print("fuck")
				mobj.followmic = mo
				mo.grabarrom = mobj
			end
		end
		if mo.grabarrom and mo.grabarrom.valid
			P_TeleportMove(mo.grabarrom, mo.x, mo.y, mo.z)
			mo.grabarrom.momx = mo.momx
			mo.grabarrom.momy = mo.momy
			mo.grabarrom.momz = mo.momz
		end
	end
end

addHook("MobjThinker", MicThink, MT_MIC) 

/*local function Telekines(mo)
	for mobj in mobjs.iterate()
		if mobj != mo
		and (mobj.flags & MF_ENEMY or mobj.flags & MF_MONITOR or mobj.flags & MF_BOSS or mobj.type == [MT_SPIKE 
		or mobj.type == [MT_WALLSPIKE or mobj.type == [MT_WALLSPIKEBASE or mobj.type == [MT_MIC)
			if (mobj.health > 0)

				local dist = R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y)
				if dist < 500*FRACUNIT
					local where = R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y)
					P_InstaThrust(mobj, where, -30*FRACUNIT)
				end
			end	
		end	
	end
end*/

addHook("MobjThinker", function(mo)
	if mo.color == SKINCOLOR_HEAVYB
		if not mo.wherescale
			mo.scale = $ + FRACUNIT/15
		else
			if mo.tpto
				P_TeleportMove(mo, mo.tpto.x, mo.tpto.y, mo.tpto.z)
				mo.momx = mo.tpto.momx
				mo.momy = mo.tpto.momy
				mo.momz = mo.tpto.momz
				mo.state = mo.tpto.state
				mo.angle = mo.tpto.player.drawangle
			end
			mo.scale = $ - FRACUNIT/15
			if mo.wherescale
				if mo.scale < mo.wherescale
					mo.scale = mo.wherescale
				end
			end	
		end
	end	
	if mo.wherescale
		if mo.tpto
			P_TeleportMove(mo, mo.tpto.x, mo.tpto.y, mo.tpto.z)
			//mo.momx = mo.tpto.momx
			//mo.momy = mo.tpto.momy
			//mo.momz = mo.tpto.momz
			mo.state = mo.tpto.state
			mo.angle = mo.tpto.player.drawangle
		end
		mo.scale = $ - FRACUNIT/15
		if mo.wherescale
			if mo.scale < mo.wherescale
				mo.scale = mo.wherescale
			end
		end
	end
end, MT_GHOST)

addHook("TouchSpecial", function(arrow, mo)
	if arrow.valid and arrow.type == MT_BFARROW and (arrow.state == S_BFARROW or arrow.state == S_DOWNBFARROW)
		if mo.valid
		and not arrow.nope
			arrow.user = mo
			if arrow.state == S_DOWNBFARROW
				arrow.state = S_DOWNBFARROWUSE
			else
				arrow.state = S_BFARROWUSE
			end
			if arrow.color == SKINCOLOR_GREEN
				if not mo.player.boostmode
					mo.updash = 25
				else
					mo.updash = 1
				end	
				GhostAbsorb(mo, SKINCOLOR_JUMPBOOSTG)
			end
			if arrow.color == SKINCOLOR_BLUE
				mo.player.heavy = 200
				GhostAbsorb(mo, SKINCOLOR_HEAVYB)
			end
			if arrow.color == SKINCOLOR_PURPLE or arrow.color == SKINCOLOR_RED
				P_InstaThrust(mo, mo.angle, 60*FRACUNIT)
				mo.player.boostmode = 100
				mo.player.boostcolor = arrow.color
				S_StartSound(mo, sfx_s3ka2)
				if mo.updash >= 1
					mo.updash = 1
				end
				if mo.player.boostmode
					mo.player.boostcombo = $ + 1
					if mo.player.boostcombo >= 6
						//P_PlayJingleMusic(player, "GAS", nil, true, JT_OTHER)
						S_StartSound(mo, sfx_gas)
						S_FadeMusic(0, 5, mo.player)
					end
				end
				GhostAbsorb(mo, boostcolor[arrow.color])
			end
		end
		return true
	end
end, MT_BFARROW)

addHook("PlayerSpawn", function(player)
	if player.valid and player.mo.skin == "boyfriend" and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		player.arrowcount = 0
		player.micthrow = false
		player.grapple = false
		player.rapbattle = false
		if player.arrows
			if player.arrows[1]
			and player.arrows[1].valid
				P_KillMobj(player.arrows[1])
			end
			if player.arrows[2]
			and player.arrows[2].valid
				P_KillMobj(player.arrows[2])
			end
		end	
	end
	if player.valid and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		player.boostcombo = 0
		player.boostmode = 0
		player.heavy = 0
		player.updash = -1
	end
end)

freeslot("sfx_micdro")

addHook("MobjDeath", function(mo)
	if mo.skin == "boyfriend"
		local mic = P_SpawnGhostMobj(mo)
		mic.state = S_MIC
		mic.fuse = 250
		mic.flags = MF_NOCLIPTHING
		mic.scale = FRACUNIT/2
		P_InstaThrust(mic, mo.angle+ANGLE_90+ANGLE_45, 2*FRACUNIT)
		P_SetObjectMomZ(mic, 15*FRACUNIT)
	end
end, MT_PLAYER)

local function ArrowDeath(arrow)
	if arrow.whocreator
		if arrow.whocreator.player.arrowcount
			arrow.whocreator.player.arrowcount = $ - 1
			arrow.whocreator.player.arrows[arrow.whocreator.player.arrowcount] = nil
		end	
	end	
	ArrowSplash(arrow, arrow.color)
	if arrow.state == S_DOWNBFARROW or arrow.state == S_DOWNBFARROWUSE
		arrow.state = S_DOWNBFARROWUSE
	end
end

addHook("MobjDeath", ArrowDeath, MT_BFARROW)
addHook("MobjDamage", ArrowDeath, MT_BFARROW)
addHook("MobjFuse", function(arrow)
	if arrow.whocreator
		if arrow.whocreator.player.arrowcount
			arrow.whocreator.player.arrowcount = $ - 1
			arrow.whocreator.player.arrows[arrow.whocreator.player.arrowcount] = nil
		end	
	end	
	ArrowSplash(arrow, arrow.color)
end, MT_BFARROW)

addHook("MobjFuse", function(mo)
	if mo.state == S_BFARROW or mo.state == S_DOWNBFARROW
		ArrowSplash(mo, mo.color)
		for i = 1, 15
			local ns = i*(24*ANG1)
			local some = P_SpawnMobj(mo.x, mo.y, mo.z+50*FRACUNIT, MT_WALLSPIKE)
			some.fuse = 15
			some.flags = $|MF_MISSILE
			some.angle = ns
			P_InstaThrust(some, ns, 15*FRACUNIT)
		end
	end	
end, MT_THOK)

addHook("MobjThinker", function(mo)
	if mo.state == S_MIC
		if not P_IsObjectOnGround(mo)
			mo.rollangle = $ + 15*ANG1
		else
			if mo.rollangle > 0
				mo.rollangle = 0
			else
				mo.rollangle = ANGLE_180
			end
			if mo.eflags & MFE_JUSTHITFLOOR
				S_StartSound(mo, sfx_micdro)
			end
		end	
	end
end, MT_GHOST)

addHook("MobjDeath", function(mo)
	if mo.thrower
		mo.thrower.player.micthrow = false
		mo.thrower.player.grapple = false
		mo.thrower.player.stopgrapple = false
	end	
end, MT_MIC)

local function playercollide(mo, mobj)
	
    if mo.valid
	and (mo.type == MT_PLAYER)
	and mobj.valid
	and (mobj.type == MT_PLAYER)
    
        if (mo.z > mobj.z+mobj.height)
        or (mobj.z > mo.z+mo.height)
        return
        end

        if mobj.player.boostmode
			mo.player.boostmode = 50
			P_Thrust(mo, mo.player.drawangle, 30*FRACUNIT)
		end
        return false

    end
end

addHook("MobjCollide", playercollide, MT_NULL)
addHook("MobjMoveCollide", playercollide, MT_NULL)


local function miccollide(mo, mobj)
	
    if mo.valid
	and (mo.type == MT_PLAYER)
	and mobj.valid
	and (mobj.type == MT_MIC)
	and mobj.thrower == mo
    
        if (mo.z > mobj.z+mobj.height)
        or (mobj.z > mo.z+mo.height)
        return
        end

		if mobj.thrower
			if mobj.attract == true
				mobj.thrower.player.micthrow = false
				mobj.attract = false
				P_KillMobj(mobj)
				if not P_IsObjectOnGround(mobj.thrower)
					mo.player.pflags = $|PF_THOKKED
				end
			end
			if mobj.thrower.player.grapple == true
				mobj.thrower.player.micthrow = false
				mobj.attract = false
				P_KillMobj(mobj)
				if not P_IsObjectOnGround(mobj.thrower)
					mo.player.pflags = $|PF_THOKKED
				end
				if mobj.thrower.player.stopgrapple == false
					mobj.thrower.momx = 0
					mobj.thrower.momy = 0
					if not P_IsObjectOnGround(mobj.thrower)
						P_SetObjectMomZ(mobj.thrower, 8*FRACUNIT)
						mobj.thrower.player.pflags = $|PF_JUMPED|PF_THOKKED
					end	
				end	
			end	
		end	
        return false

    end
end

addHook("MobjCollide", miccollide, MT_NULL)
addHook("MobjMoveCollide", miccollide, MT_NULL)

if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["boyfriend"] = 12

addHook("PlayerThink", function(player)
	if player.valid
		if player.micx == nil
			player.micx = 0
		end
		if player.micy == nil
			player.micy = 0
		end
		if player.micxy == nil
			player.micxy = 1
		end
		if player.arrowappear == nil
			player.arrowappear = -50
		end
		if player.arrowappear2 == nil
			player.arrowappear2 = 0
		end
		if player.themissile and player.wheremissile and player.wheremissile <= 1000*FRACUNIT
			player.arrowappear = $ + player.arrowappear2
			player.arrowappear2 = $ + 1
			if player.arrowappear > 50
				player.arrowappear = 50
				player.arrowappear2 = 0
			end
		else
			player.arrowappear = $ - player.arrowappear2
			player.arrowappear2 = $ + 1
			if player.arrowappear < -50
				player.arrowappear = -50
				player.arrowappear2 = 0
			end
		end
		if player.arrowappear < -50
			player.arrowappear = -50
			player.arrowappear2 = 0
		end
		if player.arrowappear > 50
			player.arrowappear = 50
			player.arrowappear2 = 0
		end	
		if player.arrowappear2 < 0
			player.arrowappear2 = 0
		end
		if player.arrowappear2 > 100
			player.arrowappear2 = 100
		end	
		player.micxy = $ + player.bob
		if player.micthrow != true
			if player.micthrown == true
				player.micy = $ - FRACUNIT*15
				if player.micy <= 0
					player.micthrown = false
				end
			end
			if player.micthrown != true
				if not player.sing
					if P_IsObjectOnGround(player.mo)
						player.micx = FRACUNIT + FixedMul(sin(player.micxy/FRACUNIT*ANG1), FRACUNIT*25)
						player.micy = FRACUNIT - FixedMul(sin((player.micxy*2)/FRACUNIT*ANG1), FRACUNIT*25)/2
					else
						player.micx = 1
						player.micy = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT*50)
					end
				end	
			end	
			if player.sing
				if player.left
					player.micx = $ - FRACUNIT/5
				end
				if player.right
					player.micx = $ + FRACUNIT/5
				end
				if player.down
					player.micy = $ + FRACUNIT
				end
				if player.up
					player.micy = $ - FRACUNIT
				end
				if player.mo.state == S_PLAY_SPRINGARROW
					player.micy = $ - FRACUNIT
				end
				if player.mo.state == S_PLAY_TIMEARROW
					player.micy = $ + FRACUNIT
				end
				if player.mo.state == S_PLAY_BOOSTARROW
					player.micx = $ - FRACUNIT
				end
			end	
		else
			player.micthrown = true
			player.micx = 1
			if player.micy < 250*FRACUNIT
				player.micy = $ + 15*FRACUNIT
			end	
		end
		//print("X:"..130 + player.micx/FRACUNIT, "Y:"..50+player.micy/FRACUNIT)
	end
end)

local function BFHand(v, player, cam)
	if (player.mo.skin == "boyfriend") and player.valid and not cam.chase
		local bfhand = v.cachePatch("BFHAND")
	
		if player.micthrow == true
			bfhand = v.cachePatch("BFHANDL")
		end
		if player.sing
			if player.left
				bfhand = v.cachePatch("BFHANDL")
			end
			if player.right
				bfhand = v.cachePatch("BFHANDR")
			end
			if player.down
				bfhand = v.cachePatch("BFHANDL")
			end
			if player.up
				bfhand = v.cachePatch("BFHANDL")
			end
			if not (player.up or player.left or player.right or player.down)
				bfhand = v.cachePatch("BFHANDL")
			end
		end
		if player.micxy
		and bfhand
			v.drawScaled(160*FRACUNIT+player.micx, 80*FRACUNIT+player.micy, FRACUNIT/4, bfhand, V_SNAPTOBOTTOM|V_SNAPTORIGHT)
		end	
	end
end

hud.add(BFHand)

local function ArrowIcons(v, player, cam)
	if player.valid
		local x = hudinfo[HUD_POWERUPS].x*FRACUNIT
		local y = hudinfo[HUD_POWERUPS].y*FRACUNIT
		local f = V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER
		local sep = 20*FRACUNIT
		if (CV_FindVar("powerupdisplay").value == 2 or CV_FindVar("powerupdisplay").value == 1) and not cam.chase
			if player.boostcolor
				if player.boostmode
					//v.drawScaled(130*FRACUNIT, 50*FRACUNIT, FRACUNIT/4, v.getSpritePatch(SPR_AROW, A), V_SNAPTOBOTTOM|V_SNAPTORIGHT, v.getColormap("sonic", boostcolor[player.boostcolor]))
					if player.boostmode > 3*TICRATE
						v.drawScaled(x+5*FRACUNIT-20*FRACUNIT,y+20*FRACUNIT,FRACUNIT/4,v.getSpritePatch(SPR_BFAR, A),f, v.getColormap("sonic", boostcolor[player.boostcolor]))
						v.drawString(x+13*FRACUNIT-20*FRACUNIT,y+8*FRACUNIT,tostring(player.boostmode/TICRATE),f,"thin-fixed-right")
					end
					if (player.boostmode <= 3*TICRATE and player.boostmode%2 == 0)
						v.drawScaled(x+5*FRACUNIT-20*FRACUNIT,y+20*FRACUNIT,FRACUNIT/4,v.getSpritePatch(SPR_BFAR, A),f, v.getColormap("sonic", boostcolor[player.boostcolor]))
						v.drawString(x+13*FRACUNIT-20*FRACUNIT,y+8*FRACUNIT,tostring(player.boostmode/TICRATE),f,"thin-fixed-right")
					end
					x = $ - sep
				end
			end	
			if player.mo.updash
				//v.drawScaled(130*FRACUNIT, 50*FRACUNIT, FRACUNIT/4, v.getSpritePatch(SPR_AROW, A), V_SNAPTOBOTTOM|V_SNAPTORIGHT, v.getColormap("sonic", SKINCOLOR_JUMPBOOSTG))
				if player.mo.updash > 3*TICRATE
					v.drawScaled(x+5*FRACUNIT-20*FRACUNIT,y+20*FRACUNIT,FRACUNIT/4,v.getSpritePatch(SPR_BFAR, A),f, v.getColormap("sonic", SKINCOLOR_JUMPBOOSTG))
					v.drawString(x+13*FRACUNIT-20*FRACUNIT,y+8*FRACUNIT,tostring(player.mo.updash/TICRATE),f,"thin-fixed-right")
				end
				if (player.mo.updash <= 3*TICRATE and player.mo.updash%2 == 0)
					v.drawScaled(x+5*FRACUNIT-20*FRACUNIT,y+20*FRACUNIT,FRACUNIT/4,v.getSpritePatch(SPR_BFAR, A),f, v.getColormap("sonic", SKINCOLOR_JUMPBOOSTG))
					v.drawString(x+13*FRACUNIT-20*FRACUNIT,y+8*FRACUNIT,tostring(player.mo.updash/TICRATE),f,"thin-fixed-right")
				end
				x = $ - sep
			end
			if player.heavy
				//v.drawScaled(130*FRACUNIT, 50*FRACUNIT, FRACUNIT/4, v.getSpritePatch(SPR_DARW, A), V_SNAPTOBOTTOM|V_SNAPTORIGHT, v.getColormap("sonic", SKINCOLOR_HEAVYB))
				if player.heavy > 3*TICRATE
					v.drawScaled(x+5*FRACUNIT-20*FRACUNIT,y+20*FRACUNIT,FRACUNIT/4,v.getSpritePatch(SPR_BFDA, A),f, v.getColormap("sonic", SKINCOLOR_HEAVYB))
					v.drawString(x-20*FRACUNIT+13*FRACUNIT,y+8*FRACUNIT,tostring(player.heavy/TICRATE),f,"thin-fixed-right")
				end
				if (player.heavy <= 3*TICRATE and player.heavy%2 == 0)
					v.drawScaled(x+5*FRACUNIT-20*FRACUNIT,y+20*FRACUNIT,FRACUNIT/4,v.getSpritePatch(SPR_BFDA, A),f, v.getColormap("sonic", SKINCOLOR_HEAVYB))
					v.drawString(x-20*FRACUNIT+13*FRACUNIT,y+8*FRACUNIT,tostring(player.heavy/TICRATE),f,"thin-fixed-right")
				end
				x = $ - sep
			end
		end	
	end	
end
hud.add(ArrowIcons)		

freeslot("SPR_BFAR", "SPR_AIM")

local function Dodge(v, player, cam)
	if (player.mo.skin == "boyfriend") and player.valid
		local f = V_HUDTRANS|V_20TRANS|V_PERPLAYER
		if player.wheremissile and player.wheremissile <= 1000*FRACUNIT 
		and player.themissile
		and player.prewheremissile
		and player.wheremissile <= player.prewheremissile
			local arrow = v.cachePatch("WARNCOLOR")
			if arrow and not player.dodge
				v.draw(160, (player.wheremissile/FRACUNIT)-25, arrow, f, v.getColormap("sonic", SKINCOLOR_YELLOW))
			end	
		end	
		local arrowpress = v.cachePatch("WARNGREY")
		if player.dodge
			arrowpress = v.cachePatch("WARNGREEN")
		else
			arrowpress = v.cachePatch("WARNGREY")
		end
		if arrowpress and player.arrowappear
			if player.dodge
				v.drawScaled(160*FRACUNIT, (player.arrowappear+5)*FRACUNIT, FRACUNIT+FRACUNIT/15,arrowpress, f, v.getColormap("sonic", SKINCOLOR_YELLOW))
			else
				v.draw(160, player.arrowappear, arrowpress, f, v.getColormap("sonic", SKINCOLOR_GREY))
			end	
		end	
	end
end

hud.add(Dodge)

addHook("ShouldDamage", function(mo, mobj)
	if (mo.skin == "boyfriend") and mo.valid
		if mo.player.dodge > 0
			return false
		end
	end
end)

addHook("TouchSpecial", function(mobj, mo)
	if mobj.valid and mo.valid
		if mo.player
			if mo.player.micthrow == true
				mo.player.micthrow = false
			end
		end
	end
end, MT_STARPOST)

local rs_loaded = false
addHook("ThinkFrame", do
	if RingSlinger and not rs_loaded
		rs_loaded = true;
		
		print("Loaded RingSlinger NEO support for Funkin' Chars!")
		
		--Define RS NEO stuff here.
		RingSlinger.Skins["boyfriend"] = {
			ammo = 50,--Maximum ammo.
			weapons = {RSWPN_GRENADE, RSWPN_SEEKER}--Main, offhand
		}
	end
end)

