freeslot("SPR2_UP__", "SPR2_DOWN", "SPR2_RIGH", "SPR2_LEFT", "S_PLAY_LEFT", "S_PLAY_RIGHT", "S_PLAY_DOWN", "S_PLAY_UP")

states[S_PLAY_UP] = {
	sprite = SPR_PLAY,
	frame = SPR2_UP__,
	tics = 5,
	nextstate = S_PLAY_UP
}
states[S_PLAY_DOWN] = {
	sprite = SPR_PLAY,
	frame = SPR2_DOWN,
	tics = 5,
	nextstate = S_PLAY_DOWN
}

states[S_PLAY_LEFT] = {
	sprite = SPR_PLAY,
	frame = SPR2_LEFT,
	tics = 5,
	nextstate = S_PLAY_LEFT
}
states[S_PLAY_RIGHT] = {
	sprite = SPR_PLAY,
	frame = SPR2_RIGH,
	tics = 5,
	nextstate = S_PLAY_RIGHT
}

freeslot(
	"sfx_flbf",
	"sfx_fdbf",
	"sfx_fubf",
	"sfx_frbf",
	"sfx_slbf",
	"sfx_sdbf",
	"sfx_subf",
	"sfx_srbf",
	"sfx_plbf",
	"sfx_pdbf",
	"sfx_pubf",
	"sfx_prbf",
	"sfx_mlbf",
	"sfx_mdbf",
	"sfx_mubf",
	"sfx_mrbf",
	"sfx_elbf",
	"sfx_edbf",
	"sfx_eubf",
	"sfx_erbf",
	"sfx_rlbf",
	"sfx_rdbf",
	"sfx_rubf",
	"sfx_rrbf"
)

local left = {
sfx_flbf,
sfx_slbf,
sfx_plbf,
sfx_mlbf,
sfx_elbf,
sfx_rlbf
}

local down = {
sfx_fdbf,
sfx_sdbf,
sfx_pdbf,
sfx_mdbf,
sfx_edbf,
sfx_rdbf
}

local up = {
sfx_fubf,
sfx_subf,
sfx_pubf,
sfx_mubf,
sfx_eubf,
sfx_rubf
}

local right = {
sfx_frbf,
sfx_srbf,
sfx_prbf,
sfx_mrbf,
sfx_erbf,
sfx_rrbf
}

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.mo.skin == "boyfriend" and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if player.sing == nil
			player.sing = 0
		end
		if player.sing
			player.sing = $1 - 1
		end
		if player.rapbattle == nil
			player.rapbattle = false
		end
		if player.sing == 0
		and player.mo.state != S_PLAY_STND
			player.mo.state = S_PLAY_STND
		end	
		if player.cmd.buttons & BT_TOSSFLAG
			if player.rapbattle
				player.thrustfactor = skins[player.mo.skin].thrustfactor
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.jumpfactor = skins[player.mo.skin].jumpfactor
				player.accelstart = skins[player.mo.skin].accelstart
				player.acceleration = skins[player.mo.skin].acceleration
				player.rapbattle = false
			else
				player.rapbattle = true
			end
			player.toosflag = true
		else
			player.toosflag = false
		end
		if player.rapbattle == true
			player.thrustfactor = 0
			player.normalspeed = 0
			player.jumpfactor = 0
			player.accelstart = 0
			player.acceleration = 0
		end
		if player.rapbattle == true
			if player.cmd.sidemove <= -35 and player.left == false
				player.mo.state = S_PLAY_LEFT
				player.sing = 10
				S_StartSound(player.mo, left[P_RandomRange(1, 6)])
			end	
			if player.cmd.sidemove >= 35 and player.right == false
				player.mo.state = S_PLAY_RIGHT
				player.sing = 10
				S_StartSound(player.mo, right[P_RandomRange(1, 6)])
			end	
			if (player.cmd.forwardmove <= -35
			or player.cmd.buttons & BT_SPIN) and player.down == false
				player.mo.state = S_PLAY_DOWN
				player.sing = 10
				S_StartSound(player.mo, down[P_RandomRange(1, 6)])
			end	
			if (player.cmd.forwardmove >= 35
			or player.cmd.buttons & BT_JUMP) and player.up == false
				player.mo.state = S_PLAY_UP
				player.sing = 10
				S_StartSound(player.mo, up[P_RandomRange(1, 6)])
			end	
			if player.cmd.forwardmove <= -35
			or player.cmd.buttons & BT_SPIN
				player.down = true
			else
				player.down = false
			end
			if player.cmd.forwardmove >= 35
			or player.cmd.buttons & BT_JUMP
				player.up = true
			else
				player.up = false
			end
			if player.cmd.sidemove <= -35
				player.left = true
			else
				player.left = false
			end
			if player.cmd.sidemove >= 35
				player.right = true
			else
				player.right = false
			end
		end
	end
end)	