COM_AddCommand("sing", function(player, arg, arg2, arg3)
	if player and player.valid
		local chrom = nil
		local note = nil
		local dur = 10
		
		if arg
			chrom = tostring(string.lower(arg))
		end
		if arg2
			note = tostring(string.lower(arg2))
		end
		if arg3
			dur = tonumber(arg3)
		end	
		
		if chrom == "nil"
			chrom = nil
		end
		if note == "nil"
			note = nil
		end
		
		if FNF_Chromatics //If chromatics exist even
			if chrom and FNF_Chromatics[chrom] //If the chromatic you chose exist
				if note //If the note you chose exists
				and FNF_Chromatics[chrom][note] 
					local sound = FNF_Chromatics[chrom][note]["start"]
					S_StartSound(player.mo, sound) //If it does then play sound
					if dur and sound //If you also set a duration add it to the duration table
						if not player.notedur
							player.notedur = {}
						end
						player.notedur[sound] = {}
						player.notedur[sound][note] = dur
						player.notedur[sound]["return"] = sound
					end
				else //Default note
					local sound
					if FNF_Chromatics[chrom]["a"] //Same
					and FNF_Chromatics[chrom]["a"]["start"]
						sound = FNF_Chromatics[chrom]["a"]["start"]
						S_StartSound(player.mo, sound)
					end
					if dur and sound
						if not player.notedur
							player.notedur = {}
						end
						player.notedur[sound] = {}
						player.notedur[sound]["a"] = dur
						player.notedur[sound]["return"] = sound
					end
				end	
			else //Default chromatic
				CONS_Printf(player, "A command to sing like in FNF!")
				CONS_Printf(player, "sing <character/chromatic> <note> <duration>")
				CONS_Printf(player, "character/chromatic - The voice bank you wanna use.")
				CONS_Printf(player, "note - The note for the voice you chose.")
				CONS_Printf(player, "duration - duration of singing in tics (35 is a second)")
			end
		end	
	else
		CONS_Printf(player, "You need to be in-game!") //Gotta be in-game to sing!
	end
end)

local function FromSoundToString(sound)
	if FNF_SoundToString[sound]
		local soun = {}
		soun.chars = FNF_SoundToString[sound]["char"]
		soun.note = FNF_SoundToString[sound]["note"]
		soun.types = FNF_SoundToString[sound]["type"]
		
		return soun
	end	
end

addHook("PlayerThink", function(player) //Sustain note
	if player.valid
		if not player.notedur
			player.notedur = {}
		end
		if player.notedur //Very complicted code that even i dont know even tho i made it
			for k,v in pairs(player.notedur) do
				if player.notedur[k]
					local sond = player.notedur[k]["return"]
					if sond
						local sound = FromSoundToString(sond)
						if sound and sound.note and player.notedur[sond][sound.note]
							player.notedur[sond][sound.note] = $ - 1
							if not S_SoundPlaying(player.mo, sond)
							and not S_SoundPlaying(player.mo, FNF_Chromatics[sound.chars][sound.note]["loop"])
								S_StartSound(player.mo, FNF_Chromatics[sound.chars][sound.note]["loop"])
							end
							if player.notedur[sond][sound.note] == 1
								S_StartSound(player.mo, FNF_Chromatics[sound.chars][sound.note]["end"])
								if S_SoundPlaying(player.mo, FNF_Chromatics[sound.chars][sound.note]["loop"])
									S_StopSoundByID(player.mo, FNF_Chromatics[sound.chars][sound.note]["loop"])
								end	
								player.notedur[sond][sound.note] = 0
							end
						end	
					end	
				end
			end
		end
	end
end)